//---------------------------------------------------------------------------
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <limits.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <crt0.h>
#include <errno.h>
#include <dpmi.h>
#include <dos.h>
#include <sys/types.h>
#include <regex.h>

#include "memory.h"
#include "defs.h"
//---------------------------------------------------------------------------

#define VERSION MIMER_VERSION

patch		data={MIMER_SIGNATURE};
regex_t		charset_regex;

void   __crt0_load_environment_file(char *_app_name)
{;}

void MyError(int n, char *p, char *p2)
{
static char * Warnings[]={
"Unrecognized message format"
};

static char * Errors[]={
VERSION
"Usage: mimer [-{d|D} | -h<custom header> | -o<output directory>] <file1> [...]",
"Cannot create temporary file \"%s\"",
"Cannot create an output filename",
"Cannot rename \"%s\" to output filename \"%s\"",
"Cannot read input file",
"Cannot open input file \"%s\"",
"Not Enough Memory",
"Cannot delete input file",
"Delete mimer.lck and try again...",
"Can't store task information %s %s",
"Can't read task information",
"Regular expression is invalid"
};
char buf[512];

enable();

if (n<100)
   sprintf(buf,Errors[n],p,p2);
else
   sprintf(buf,Warnings[n-100],p,p2);


//fputc('\n',stderr);
//if (n<100)
//   fprintf(stderr,Errors[n],p,p2,errno);
//else
//   fprintf(stderr,Warnings[n-100],p,p2);

if (n)
   {
   perror(buf);
   getchar();
   }
else
   fprintf(stderr,buf);

if (n<100)
   exit(-1);
}

//---------------------------------------------------------------------------
// NULL = exist
// path = not exist
char * chktmp(char *path, int mustcreat)
{
int fd;

if (mustcreat)
   {
   if ((fd=open(path,O_WRONLY|O_CREAT|O_EXCL,S_IWUSR)) < 0)
      return(NULL);
   close(fd);
   return(path);
   }

if (((fd=open(path,O_RDONLY)) < 0) && (errno==ENOENT))
   return(path);
close(fd);
return(NULL);
}

char * unique(char *inpath, char *ext, int mustcreat)
{
static char   path[ PATH_MAX ];
char tmp[10];

char *p;
int   n;

/* getpid
 * Get the time of day in hex seconds since 1970 to use as a "random"
 * number for this file. The result is 8 hex digits plus NULL, we will
 * use the last 5 digits.
 */

strcpy(path, inpath);
if (path[(n=strlen(path)) - 1] != '\\' )
   {
   strcat(path, "\\");
   n++;
   }

if (n>= PATH_MAX -13)
    MyError(NoFreeName);

p=path+n;
itoa(getpid(),p+5,36);
itoa(time(NULL),tmp,36);
memcpy(p,tmp,6);

strcat(path,ext);
for(p[0]='A';p[0]<='Z';p[0]++)
   for(p[1]='A';p[1]<='Z';p[1]++)
      for(p[2]='A';p[2]<='Z';p[2]++)
         if (chktmp(path,mustcreat) != NULL )
            return(path);

MyError(NoFreeName);
}
//---------------------------------------------------------------------------
//static char mutexname[PATH_MAX];

//int getmutex(char * p)
//{
//time_t          tm;
//int             fd;

//__dpmi_begin_critical_section();

/*
for (tm=time(NULL)+60;((fd=open(p,O_WRONLY|O_CREAT|O_EXCL,S_IWRITE)) < 0) && (tm>time(NULL));)
    __dpmi_yield();

if (fd>=0)
   close(fd);
strcpy(mutexname,p);
return(fd);*/
//return(1);
//}

//void releasemutex()
//{
//remove(mutexname);
//__dpmi_end_critical_section();
//}

//---------------------------------------------------------------------------
#define CMD_SIZE  16
#define CMD_N     1024

int main(int argc, char *argv[])
{
int pass=0,j;
unsigned long  taskpos=0;
char           path[PATH_MAX];
char           ArgvT[CMD_SIZE*CMD_N];
char          *Argv[CMD_N];
char           *ppath;
char           c;
FILE           *fp;
MemoryFromFile *mff;

disable();

if (regcomp(&charset_regex,data.charset_regex,REG_EXTENDED|REG_NOSUB))
   MyError(BadRegEx);

strcat(data.xheader,"\n");
opterr = 1;

for (int i=0;i<argc;i++)
    Argv[i]=argv[i];

beg:
pass++;
optind=1;
optopt=0;
optarg=0;
while ((c=getopt(argc, Argv, "dDh:o:")) != -1)
      switch(c)
        {
        case 'd':
           data.dflag=1;
           break;

        case 'D':
           data.dflag=0;
           break;

        case 'h':
           strncpy(data.xheader,optarg,PATCH_XHEADER_SIZE-2);
           data.xheader[PATCH_XHEADER_SIZE-2]=0;
           strcat(data.xheader,"\n");
           break;

        case 'o':
           strncpy(data.dst_path,optarg,PATH_MAX-1);
           data.dst_path[PATH_MAX-1]=0;
           break;

        case '?':
            MyError(Usage);
        }

if ((argc<optind+1) || (data.dst_path[0]==0))
    MyError(Usage);

strcpy(path,data.dst_path);
ppath=path+strlen(path);
if (ppath[-1]!='\\')
   *ppath++='\\';

if (taskpos==0)
        {
        int fd;

	__dpmi_begin_critical_section();
/*        strcpy(ppath,"mimer.lck");

        if ((fd=getmutex(path))<0)
           MyError(MutexBusy);

        printf("\n path= %s",path);
        printf("\n mutex returned %d",fd);*/

        strcpy(ppath,"mimer.tsk");

        if ((fd=open(path,O_WRONLY|O_CREAT|O_EXCL,S_IWRITE))<0)
           {
           if (errno!=EEXIST)
              MyError(CantSaveTask,"errno!=EEXIST");

//           printf("\n path= %s",path);

           if ((fp=fopen(path,"ab"))==NULL)
              MyError(CantSaveTask);

           fprintf(fp,"%d\n",argc);
           for (int i=1;i<argc;i++)
               fprintf(fp,"%s\n",Argv[i]);
           if (fclose(fp))
              {
              perror("Cant' close task file");
              getchar();
              }
	   __dpmi_end_critical_section();
           enable();
           regfree(&charset_regex);
	   return(0);
           }

        close(fd);

	__dpmi_end_critical_section();
        printf(VERSION);

	mff=new(MemoryFromFile)(BUF_MAX,BUF_MIN);
        }
        
enable();

j=0;
for (int i=optind;i<argc;i++)
    {
    char name[PATH_MAX];
    char path[PATH_MAX];

    fprintf(stderr,"\r %d messages developed (pass %d)   ",j,pass);

    if (access(Argv[i],D_OK)==0)
       continue;
    
    strcpy(name,unique(data.dst_path,".L$M",1));
    if ((fp=fopen(name,"wb"))==NULL)
        MyError(CantOpenOutput,name);
    mff->Open(Argv[i]);
    mff->Read(0);
    mff->DevelopMail(fp,data.xheader);
    mff->Close();
    fclose(fp);

    strcpy(path,name);
    strcpy(path+strlen(path)-3,data.dst_xtension+1);

    if (chktmp(path,0)==NULL)
        strcpy(path,unique(data.dst_path,data.dst_xtension,0));
    if (_rename(name,path))
        MyError(CantRename,name,path);

    if (data.dflag)
       if (unlink(Argv[i]))
          MyError(UnlinkFail);
    j++;
    }

fprintf(stderr,"\r %d messages developed (pass %d)   ",j,pass);


//strcpy(ppath,"mimer.lck");
//disable();
//if (getmutex(path)<0)
//   MyError(MutexBusy);

__dpmi_begin_critical_section();

strcpy(ppath,"mimer.tsk");

fp=fopen(path,"rb");

if (fp==NULL)
   MyError(CantReadTask);

fseek(fp,taskpos,SEEK_SET);

if (fscanf(fp,"%d",&argc)<=0)
   {
   fclose(fp);
   remove(path);
   __dpmi_end_critical_section();
//   releasemutex();

   delete(mff);

   regfree(&charset_regex);
   return(0);
   }

Argv[1]=ArgvT;

for (int i=1;i<argc;i++)
    {
    if (fscanf(fp,"%s",Argv[i])==0)
       MyError(CantReadTask);
    if ((Argv[i+1]=Argv[i]+strlen(Argv[i])+1)>ArgvT+sizeof(ArgvT))
       MyError(NoMemory);
    }

taskpos=ftell(fp);
fclose(fp);
__dpmi_end_critical_section();

//releasemutex();
// enable();
goto beg;

return 0;
}
//---------------------------------------------------------------------------
