#ifndef dataH
#define dataH

#include <time.h>
#include <limits.h>

#define PATCH_SIGNATURE_SIZE		16
#define PATCH_RE_CHARSET_LIST_SIZE	64
#define PATCH_CHARSET_NAME_SIZE		16
#define PATCH_CHARSET_NUMBER		8
#define PATCH_XHEADER_SIZE		64
#define PATCH_DST_XTN_SIZE		5

enum charset_reliability_t {RELIABLE, UNRELIABLE};

struct patch
	{
        char signature[PATCH_SIGNATURE_SIZE];

	charset_reliability_t charset_reliability;
       	char charset_regex[PATCH_RE_CHARSET_LIST_SIZE];

        char		xheader[PATCH_XHEADER_SIZE];
        unsigned short	dflag;
        
        unsigned short	charset_number;
        char		charset_name[PATCH_CHARSET_NUMBER][PATCH_CHARSET_NAME_SIZE];
        unsigned char	charset_table[PATCH_CHARSET_NUMBER][256];

        char		dst_path[PATH_MAX];

        unsigned short	frequencies[256][256];
        double		factor;

        time_t		time_stamp;

	char		dst_xtension[PATCH_DST_XTN_SIZE];
        };
#endif   //dataH
